<?php

/**
* OCMS version 3.0
* @author yann.schluchter@ouebe.ch
* @copyright 2004 
* @disclaimer This code is freely given to you "AS IS", so if it damages computer, formats your hard disk or burns your house, I am not the one to blame.
*/

/**
* Returns the URL of an image. If the image doesn't exist on the database, it returns "p.gif".
*/
function image($i_int_image_id) {

	global $obj_dbc;
	global $STR_TABLES_PREFIX;
	
	$str_image_file_name = "p.gif";

	$rs_index = $obj_dbc->execute("SELECT type FROM " . $STR_TABLES_PREFIX . "images WHERE id=$i_int_image_id");

	if ($rs_index) {
	
		if (mysql_num_rows($rs_index) > 0) {
		
			$str_image_type = mysql_result($rs_index, 0, 'type');
								        	
			if (($str_image_type == "image/pjpeg") or ($str_image_type == "image/jpeg")) $str_extension = "jpg";
			if ($str_image_type == "image/gif") $str_extension = "gif";
			if (($str_image_type == "image/png") or ($str_image_type == "image/x-png")) $str_extension = "png";
		
			$str_image_file_name = "images/img" . $i_int_image_id . "." . $str_extension;
		}
	}
	else {
	
		echo("index.php (image): Data access error<br>");
	}
	
	return $str_image_file_name;
}

/**
* Returns the URL of the thumbnail of an image. If the image doesn't exist on the database, it returns "p.gif".
*/
function thumbnail($i_int_image_id) {

	global $obj_dbc;
	global $STR_TABLES_PREFIX;
	
	$rs_index = $obj_dbc->execute("SELECT type FROM " . $STR_TABLES_PREFIX . "images WHERE id=$i_int_image_id");

	if ($rs_index) {
	
		if (mysql_num_rows($rs_index) > 0) {
		
			return "images/img" . $i_int_image_id . "_t.jpg";
		}
		else {
		
			return "p.gif";
		}
	}
	else {
	
		echo("index.php (thumbnail): Data access error<br>");
	}
}

/**
* create the thumbnail of an image.
*/
function createThumbnail($i_int_image_id, $i_str_format, $i_str_directory) {
 	
 	// Load the image (JPG, GIF or PNG)
 	if ($i_str_format == "jpg") $res_source_image = @imagecreatefromjpeg("$i_str_directory/img" . $i_int_image_id . ".jpg");
 	if ($i_str_format == "gif") $res_source_image = @imagecreatefromgif("$i_str_directory/img" . $i_int_image_id . ".gif");
 	if ($i_str_format == "png") $res_source_image = @imagecreatefrompng("$i_str_directory/img" . $i_int_image_id . ".png");
 	
 	if ($res_source_image) {
 	
		// Resize the image if necessary
		if ((imagesx($res_source_image) > 100) or (imagesy($res_source_image) > 100)) {

			// Calculate the image ratio
			$int_ratio = imagesy($res_source_image) / imagesx($res_source_image);

			if (imagesx($res_source_image) >= imagesy($res_source_image)) {

				$int_width = 100;
				$int_height = 100 * $int_ratio;
			}
			else {

				$int_width = 100 / $int_ratio;
				$int_height = 100;
			}

			$res_thumbnail = imagecreatetruecolor($int_width, $int_height);

			imagecopyresampled($res_thumbnail, $res_source_image, 0, 0, 0, 0, $int_width, $int_height, imagesx($res_source_image), imagesy($res_source_image));
		}
		else {

			$res_thumbnail = $res_source_image;
		}
		
		// Save the thumbnail as JPG image
		imagejpeg($res_thumbnail,  "$i_str_directory/img" . $i_int_image_id . "_t.jpg");

		// Free memory
		imagedestroy($res_thumbnail);
		imagedestroy($res_source_image);
	}	
}

/**
* Saves an image in the database and on the file system. It also create the thumbnail of the image.
*/
function saveImage($i_int_id, $i_str_title, $i_str_description, $i_int_size, $i_str_type, $i_int_width, $i_int_height, $i_int_folder_id, $i_str_data, $i_int_file_size, $i_str_directory) {

	global $obj_dbc;
	global $STR_TABLES_PREFIX;
	
	if ($i_int_id == -1) {
	
		$obj_dbc->execute("INSERT INTO " . $STR_TABLES_PREFIX . "images (description, title, size, type, width, height, folder_id) VALUES ('$i_str_description', '$i_str_title', $i_int_size, '$i_str_type', $i_int_width, $i_int_height, $i_int_folder_id)");
		
		$int_id = mysql_insert_id();
	}
	else {
	
		$obj_dbc->execute("UPDATE " . $STR_TABLES_PREFIX . "images SET description='$i_str_description', title='$i_str_title', size=$i_int_size, type='$i_str_type', width=$i_int_width, height=$i_int_height, folder_id=$i_int_folder_id WHERE id=$i_int_id");
		$int_id = $i_int_id;
		
	}
	
	// Get the image type (JPG, GIF or PNG)
	if (($i_str_type == "image/pjpeg") or ($i_str_type == "image/jpeg")) $str_extension = "jpg";
	if ($i_str_type == "image/gif") $str_extension = "gif";
	if (($i_str_type == "image/png") or ($i_str_type == "image/x-png")) $str_extension = "png";

	if ($str_extension != "") {

		// Save the image
		$res_output_file = fopen("$i_str_directory/img$int_id.$str_extension", "wb");
		fwrite($res_output_file, $i_str_data, $i_int_file_size);
		fclose($res_output_file);

		// Create the thumbnail (JPG)
		createThumbnail($int_id, $str_extension, $i_str_directory);
	}
	else {

		echo("OCMS error (_image_save.php) : unknown image type.");
	}
	
	return $int_id;
}

/**
* Returns the URL of a page. If the page doesn't exist in the database, it returns "#".
*/
function page($i_int_page_id) {

	global $obj_dbc;
	global $STR_TABLES_PREFIX;
	
	$str_url = "#";

	$rs_index = $obj_dbc->execute("SELECT * FROM " . $STR_TABLES_PREFIX . "pages WHERE id=$i_int_page_id");

	if ($rs_index) {
	
		if (mysql_num_rows($rs_index) > 0) {
		
			$str_url ="index.php?p_int_page_id=$i_int_page_id";
		}
	}
	
	return $str_url;
}

/**
* Returns the URL of a file. If the file doesn't exist in the database, it returns "#".
*/
function filename($i_int_file_id) {

	global $obj_dbc;
	global $STR_TABLES_PREFIX;
	
	$str_file_name = "#";

	$rs_index = $obj_dbc->execute("SELECT * FROM " . $STR_TABLES_PREFIX . "files WHERE id=$i_int_file_id");

	if ($rs_index) {
	
		if (mysql_num_rows($rs_index) > 0) {
		
			$str_file_name = "download/$i_int_file_id-" . mysql_result($rs_index, 0, "file_name");
		}
	}
	
	return $str_file_name;
}