<?php

/**
* OCMS version 3.0
* @author yann.schluchter@ouebe.ch
* @copyright 2004 
* @disclaimer This code is freely given to you "AS IS", so if it damages computer, formats your hard disk or burns your house, I am not the one to blame.
*/

/**
* This class provides functions to manage the pages of the OCMS system.
*/
class Page {

	var $int_id;
	var $int_parent_id;
	var $str_title;
	var $str_description;
	var $int_security_level;
	var $int_position;
	var $int_template_id;
	
	/**
	* Returns a string containing informations about the page.
	*/
	function toString() {
	
		$str_buffer = "id: $this->int_id / ";
		$str_buffer .= "parent id: $this->int_parent_id / ";
		$str_buffer .= "title: $this->str_title / ";
		$str_buffer .= "description: $this->str_description / ";
		$str_buffer .= "security level: $this->int_security_level / ";
		$str_buffer .= "position: $this->int_position / ";
		$str_buffer .= "template id: $this->int_template_id / ";
		
		return $str_buffer;
	}

	/**
	* Constructor
	*/
	function Page($i_int_page_id = "") {
	
		global $obj_dbc;
		global $STR_TABLES_PREFIX;

		if ($i_int_page_id != "") {

			$rs_page = $obj_dbc->execute("SELECT * FROM " . $STR_TABLES_PREFIX . "pages WHERE id=$i_int_page_id");
		
			if ($rs_page) {
			
				if (mysql_num_rows($rs_page) > 0) {
				
					$this->int_id = $i_int_page_id;
					$this->int_parent_id = mysql_result($rs_page, 0, 'parent_id');
					$this->str_title = mysql_result($rs_page, 0, 'title');
					$this->str_description = mysql_result($rs_page, 0, 'description');
					$this->int_security_level = mysql_result($rs_page, 0, 'security_level');
					$this->int_position = mysql_result($rs_page, 0, 'position');
					$this->int_template_id = mysql_result($rs_page, 0, 'template_id');
				}
				else echo("Page class (constructor): Page not found (ID: $i_int_page_id)<br>");
			}
			else echo("Page class (constructor): Data access error<br>");
		}
		else echo("Page class (constructor): Page ID parameter missing<br>");
	}
	
	/**
	* Returns an HTTP parameter
	*/
	function parameter($i_str_name) {

		$str_parameter = $_POST[$i_str_name];
		
		if ($str_parameter == "")  $str_parameter = $_GET[$i_str_name];
		
		return $str_parameter;
	}
	
	/**
	* Returns the security level requested to display the page.
	*/
	function securityLevel() {
		
		return $this->int_security_level;
	}

	/**
	* Returns the URL of the page template.
	*/
	function templateFilename() {

		return "_ocms/_templates/_pages/pt_" . $this->int_template_id . ".php";
	}
	
	/**
	* Returns the ID of the page.
	*/
	function id() {
		
		return $this->int_id;
	}
	
	/**
	* Returns the URl of the page.
	*/
	function url() {
		
		return "index.php?p_int_page_id=" . $this->int_id;
	}
	
	/**
	* Returns the title of the page
	*/
	function title() {
		
		return $this->str_title;
	}
	
	/**
	* Returns the description of the page
	*/
	function description() {
		
		return $this->str_description;
	}
	
	/**
	* Displays the components of the page
	*/
	function components($i_str_zone_name) {

		global $obj_dbc;
		global $STR_TABLES_PREFIX;
		
		$int_zone_id = -1;
		
		$rs_page = $obj_dbc->execute("SELECT * FROM " . $STR_TABLES_PREFIX . "zones WHERE name='$i_str_zone_name'");
		
		if ($rs_page) {
			
			if (mysql_num_rows($rs_page) > 0) $int_zone_id = mysql_result($rs_page, 0, "id");
		}
		
		$rs_page = $obj_dbc->execute("SELECT " . $STR_TABLES_PREFIX . "components.id FROM " . $STR_TABLES_PREFIX . "components, " . $STR_TABLES_PREFIX . "page_component WHERE (" . $STR_TABLES_PREFIX . "components.id=" . $STR_TABLES_PREFIX . "page_component.component_id) AND (" . $STR_TABLES_PREFIX . "components.zone_id='$int_zone_id') AND (" . $STR_TABLES_PREFIX . "page_component.page_id=$this->int_id) ORDER BY " . $STR_TABLES_PREFIX . "page_component.position");
		
		if ($rs_page) {
		
			for ($int_i = 0; $int_i < mysql_num_rows($rs_page); $int_i++) {

				$obj_component = new Component(mysql_result($rs_page, $int_i, $STR_TABLES_PREFIX. 'components.id'));
				
				if ($_SESSION["s_str_mode"] == "edit") {
				
					?>
					
					<table border="0" cellpadding="0" cellspacing="0" style="Font-Family: Verdana; Font-Size: 10px;">
					
						<tr>
							<td style="Border-Top: solid #FF0000 1px; Border-Bottom: solid #FF0000 1px; Border-Left: solid #FF0000 1px; Border-Right: solid #FF0000 1px;">
					
					<?
				
				}
				
				include($obj_component->templateFilename());
				
				if ($_SESSION["s_str_mode"] == "edit") {
					
					$INT_COMPONENT_POPUP_WIDTH = 800;
					$INT_COMPONENT_POPUP_HEIGHT = 500;
					
					?>
					
							</td>
						</tr>
						
						<tr>
							<td align="right" style="Border-Bottom: solid #FF0000 1px; Border-Left: solid #FF0000 1px; Border-Right: solid #FF0000 1px;">
							
								<script language="JavaScript">

									var oEditComponentWindow;
									
									function editComponent(id) {
									
										if (oEditComponentWindow != null) {
									
											if (!oEditComponentWindow.closed) {
									
												oEditComponentWindow.close();
											}
										}
									
										oEditComponentWindow = window.open('_ocms/_admin/_component_edit.php?p_bln_online_edit=yes&p_int_component_id=' + id, 'popupComponentEdit', 'width=<?=$INT_COMPONENT_POPUP_WIDTH?>, height=<?=$INT_COMPONENT_POPUP_HEIGHT?>, toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizeable=yes, copyhistory=no, marginwidth=0, marginheight=0');
									}
									
								</script>
							
								<?=$obj_component->title()?> : <a href="javascript:editComponent(<?=$obj_component->id()?>);"><img src="_ocms/_images/stock_edit.png" border="0" align="middle"></a>
							</td>
						</tr>
					
					</table><br>
		
					<?
				
				}
			}

			mysql_free_result($rs_page);
		}
		else echo("<span class=\"clsRedText\">Page class (components): Data access error</span><br><br>");
	}
	
	/**
	* Returns the ID of the parent page
	*/
	function parentID() {
		
		return $this->int_parent_id;
	}
	
	/**
	* Returns the level of the page
	*/
	function level() {
		
		$int_level = 0;
				
		if (($this->int_id != -1) and ($this->int_parent_id != 0)) {

			$obj_page = $this->parent();

			$int_level++;

			while (($obj_page->parentID() != 0) and ($int_level < 100)) {

				$obj_page = $obj_page->parent();
				$int_level++;
			}
		}
				
		return $int_level;
	}
	
	/**
	* Returns the parent page
	*/
	function parent() {
		
		return new Page($this->int_parent_id);
	}
	
	/**
	* Returns the children pages
	*/
	function children() {
		
		global $obj_dbc;
		global $STR_TABLES_PREFIX;
		
		$arr_children = array();
		
		$rs_page = $obj_dbc->execute("SELECT id FROM " . $STR_TABLES_PREFIX . "pages WHERE parent_id=$this->int_id ORDER BY position");
		
		if ($rs_page) {
		
			for ($int_i = 0; $int_i < mysql_num_rows($rs_page); $int_i++) $arr_children[$int_i] = new Page(mysql_result($rs_page, $int_i, 'id'));
		}
		else echo("<span class=\"clsRedText\">Page class (children): Data access error</span><br><br>");
		
		return $arr_children;
	}
}
 
?>