<?php

/**
* OCMS version 3.0
* @author yann.schluchter@ouebe.ch
* @copyright 2004 
* @disclaimer This code is freely given to you "AS IS", so if it damages computer, formats your hard disk or burns your house, I am not the one to blame.
*/

/**
* This class provides functions to manage the users of the OCMS system.
*/
class User {

	var $int_id;
	var $str_login;
	var $str_description;
	var $int_security_level;
	var $str_language;
	
	/**
	* Constructor
	*/
	function User() {

			$this->int_id = -1;
			$this->str_login = "";
			$this->str_description = "";
			$this->int_security_level = 0;
			$this->str_language = "";
	}

	/**
	* Returns the login of the connected user.
	*/
	function login() {
	
		return $this->str_login;
	}

	/**
	* Returns the security level of the connected user (1..10)
	*/
	function securityLevel() {
	
		return $this->int_security_level;
	}

	/**
	* Returns the language of the user.
	*/
	function language() {
	
		return $this->str_language;
	}
	
	/**
	* Set the user's language.
	*/
	function setLanguage($i_str_language) {
		
		$this->str_language = $i_str_language;
	}

	/**
	* Disconnect the connected user.
	*/
	function logout() {
		
		$this->int_id = -1;
		$this->str_login = "";
		$this->str_description = "";
		$this->int_security_level = 0;
		$this->str_language = "";
	}

	/**
	* Try to log a user in.
	*/
	function tryToLogin($i_str_login, $i_str_password) {
	
		global $obj_dbc;
		global $STR_TABLES_PREFIX;

		$str_message = "";

		$rs_user = $obj_dbc->execute("SELECT * FROM " . $STR_TABLES_PREFIX . "users WHERE login='$i_str_login'");
		
		if ($rs_user) {
		
			if (mysql_num_rows($rs_user) > 0) {

				if (crypt(md5($i_str_password), md5($i_str_password)) == mysql_result($rs_user, 0, 'password')) {

					$this->int_id = mysql_result($rs_user, 0, 'id');
					$this->str_login = mysql_result($rs_user, 0, 'login');
					$this->str_description = mysql_result($rs_user, 0, 'description');
					$this->int_security_level = mysql_result($rs_user, 0, 'security_level');
					$this->str_language = mysql_result($rs_user, 0, 'language');
				}
				else {
				
					$str_message = "wrong password";
				}
			}
			else {
			
				$str_message = "wrong login";
			}
		}
		else echo("<span class=\"clsRedText\">User class (tryToLogin): Data access error</span><br><br>");
		
		return $str_message;
	}
	
	/**
	* Check if the connected user has access to the current page.
	*/
	function checkPageAccess($i_obj_page) {
		
		if ($this->int_security_level >= $i_obj_page->securityLevel()) {
		
			$str_message = "ok";
		}
		else {
		
			if ($this->int_id == -1) {
			
				$str_message = "need to login";
			}
			else {
			
				$str_message = "not enough rights";
			}
		}
		
		return $str_message;
	}
}

?>