<?php

/**
* OCMS version 3.0
* @author yann.schluchter@ouebe.ch
* @copyright 2004 
* @disclaimer This code is freely given to you "AS IS", so if it damages computer, formats your hard disk or burns your house, I am not the one to blame.
*/

include("_ocms/config.php");
include("_ocms/_system/_DBC.php");
include("_ocms/_system/_Page.php");
include("_ocms/_system/_User.php");
include("_ocms/_system/_Component.php");
include("_ocms/_system/_Image.php");

session_start();

// Create the session variable for the current user
if (!session_is_registered("s_obj_user")) {

	session_register("s_obj_user");
	$_SESSION["s_obj_user"] = new User();
}

// Create the session variable for the viewing mode (normal, admin_view, admin_edit)
if (!session_is_registered("s_str_mode")) {

	session_register("s_str_mode");
	$_SESSION["s_str_mode"] = "normal";
}

if ((($_GET["p_str_mode"] == "normal") or ($_GET["p_str_mode"] == "edit")) and ($_SESSION["s_obj_user"]->securityLevel() == 10)) $_SESSION["s_str_mode"] = $_GET["p_str_mode"];

// Create the database connection
$obj_dbc = new DBC();

// Create the page object
$obj_page = new Page(($_GET["p_int_page_id"] == "")?1:$_GET["p_int_page_id"]);

if ($obj_page->parameter("p_str_login") != "") $str_login_message = $_SESSION["s_obj_user"]->tryToLogin($obj_page->parameter("p_str_login"), $obj_page->parameter("p_str_password"));

if (($obj_page->parameter("p_str_login") != "") and ($str_login_message == "")) {

	// Successfull login
	
	if ($obj_page->parameter("p_bln_cookie") == "yes") {
	
		// set the cookies
		setcookie ("c_str_login", $obj_page->parameter("p_str_login"), time() + 2592000);
		setcookie ("c_str_password", $obj_page->parameter("p_str_password"), time() + 2592000);
		setcookie ("c_bln_cookie", "yes", time() + 2592000);
	}
	else {
	
		// set the cookies at null
		setcookie ("c_str_login", "", time() + 2592000);
		setcookie ("c_str_password", "", time() + 2592000);
		setcookie ("c_bln_cookie", "", time() + 2592000);
	}
}

if ($obj_page->parameter("p_str_logout") != "") $_SESSION["s_obj_user"]->logout();

if ($_SESSION["s_obj_user"]->securityLevel() != 10) $_SESSION["s_str_mode"] = "normal";

$str_access_message = $_SESSION["s_obj_user"]->checkPageAccess($obj_page);

if ($str_access_message == "ok") {

	include($obj_page->templateFilename());
}
else {
	
	include("_ocms/_templates/_login.php");
}

$obj_dbc->close();

?>